import type { JSX } from '../../stencil-public-runtime';
import type { AdjustHeightPropType, CSSResize, FocusableElement, HasCounterPropType, HideErrorPropType, IconsHorizontalPropType, IdPropType, InputTypeOnDefault, LabelWithExpertSlotPropType, MsgPropType, NamePropType, RowsPropType, ShortKeyPropType, SpellCheckPropType, Stringified, SyncValueBySelectorPropType, TextareaAPI, TextareaStates, TooltipAlignPropType } from '../../schema';
export declare class KolTextarea implements TextareaAPI, FocusableElement {
    private readonly host?;
    private textareaRef?;
    private readonly catchRef;
    getValue(): Promise<string | undefined>;
    focus(): Promise<void>;
    kolFocus(): Promise<void>;
    render(): JSX.Element;
    private readonly controller;
    _accessKey?: string;
    _adjustHeight?: boolean;
    _alert?: boolean;
    _disabled?: boolean;
    _error?: string;
    _hasCounter?: boolean;
    _hideError?: boolean;
    _hideLabel?: boolean;
    _hint?: string;
    _icons?: IconsHorizontalPropType;
    _id?: IdPropType;
    _label: LabelWithExpertSlotPropType;
    _maxLength?: number;
    _msg?: Stringified<MsgPropType>;
    _name?: NamePropType;
    _on?: InputTypeOnDefault;
    _placeholder?: string;
    _readOnly?: boolean;
    _resize?: CSSResize;
    _required?: boolean;
    _rows?: RowsPropType;
    _shortKey?: ShortKeyPropType;
    _spellCheck?: SpellCheckPropType;
    _syncValueBySelector?: SyncValueBySelectorPropType;
    _tabIndex?: number;
    _tooltipAlign?: TooltipAlignPropType;
    _touched?: boolean;
    _value?: string;
    state: TextareaStates;
    private inputHasFocus;
    constructor();
    private showAsAlert;
    validateAccessKey(value?: string): void;
    validateAdjustHeight(value?: AdjustHeightPropType): void;
    validateAlert(value?: boolean): void;
    validateDisabled(value?: boolean): void;
    validateError(value?: string): void;
    validateHasCounter(value?: HasCounterPropType): void;
    validateHideError(value?: HideErrorPropType): void;
    validateHideLabel(value?: boolean): void;
    validateHint(value?: string): void;
    validateIcons(value?: IconsHorizontalPropType): void;
    validateId(value?: string): void;
    validateLabel(value?: LabelWithExpertSlotPropType): void;
    validateMaxLength(value?: number): void;
    validateMsg(value?: Stringified<MsgPropType>): void;
    validateName(value?: string): void;
    validateOn(value?: InputTypeOnDefault): void;
    validatePlaceholder(value?: string): void;
    validateReadOnly(value?: boolean): void;
    validateResize(value?: CSSResize): void;
    validateRequired(value?: boolean): void;
    validateRows(value?: RowsPropType): void;
    validateShortKey(value?: ShortKeyPropType): void;
    validateSpellCheck(value?: SpellCheckPropType): void;
    validateSyncValueBySelector(value?: SyncValueBySelectorPropType): void;
    validateTabIndex(value?: number): void;
    validateTouched(value?: boolean): void;
    validateValue(value?: string): void;
    componentDidLoad(): void;
    componentWillLoad(): void;
    private readonly onInput;
}
